/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FECO                                                     */
/* Tabela : FERICOMP                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_FECO
BEFORE INSERT OR UPDATE OR DELETE
ON FERICOMP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUFECO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.DTFERICOMP,TO_DATE('31/12/1899','DD/MM/YYYY')) <>
          NVL(:NEW.DTFERICOMP,TO_DATE('31/12/1899','DD/MM/YYYY'))) OR
         (NVL(:OLD.CDFILIAL,0)   <> NVL(:NEW.CDFILIAL,0)) THEN
         :NEW.DTULTATUFECO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FERICOMP', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';DTFERICOMP='||TO_CHAR(:OLD.DTFERICOMP,'YYYYMMDDHH24MISS')||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FERICOMP MODIFY DTULTATUFECO DEFAULT SYSDATE
/
