/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: GERA_ETIQUETRAN

Descrio:
Gerao das etiquetas dos servios transportados

P_CDFILIAL     - Codigo da Filial
P_CDSERVFILI   - Codigo do Servio
P_CDDIETPADST  - Codigo da Dieta
P_DTSERVTRAN   - Data do Cardpio
P_CDFILAUXPRAT - Chave primria do Prato
P_CDPRATO      - Chave primria do Prato (Cdigo do Prato)
P_QTCONTCOMPST - Quantidade de containers completos
P_QTCONTAIST   - Quantidade do prato por container
P_QTPARCPRATST - Quantidade do prato no ltimo container

Para aplicar e debugar
--GERA_ETIQUETRAN '9999','001','XXXX','001','0000000001','O00001','01/01/2002','P','1111000',3,0.15,0.05
-- PRINT('xx');

Criao:
06/03/2001 - Bruno Leonardo de Oliveira

*/
IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'GERA_ETIQUETRAN' AND type = 'P')
DROP PROCEDURE GERA_ETIQUETRAN
GO

CREATE PROCEDURE GERA_ETIQUETRAN
  (@P_CDFILIAL      VARCHAR(4),
   @P_CDSERVFILI    VARCHAR(05),
   @P_CDDIETPADST   VARCHAR(4),
   @P_CDDESTFILI    VARCHAR(3),
   @P_NRSERVTRAN    VARCHAR(10),
   @P_CDCLIENTE     VARCHAR(21),
   @P_DTSERVTRAN    DATETIME,
   @P_CDFILAUXPRAT  VARCHAR(10),
   @P_CDPRATO       VARCHAR(10),
   @P_QTCONTCOMPST  NUMERIC,
   @P_QTCONTAIST    FLOAT,
   @P_QTCONTINCOST  NUMERIC,
   @P_QTPARCPRATST  FLOAT)
AS
   DECLARE @V_CONTAUXI NUMERIC;
   DECLARE @V_QTCONTINCOST NUMERIC;
BEGIN
   DELETE FROM ETIQUETRAN
   WHERE
      CDFILIAL     = @P_CDFILIAL     AND
      CDSERVFILI   = @P_CDSERVFILI   AND
      CDDESTFILI   = @P_CDDESTFILI   AND
      CDCLIENTE    = @P_CDCLIENTE    AND
      CDDIETPADST  = @P_CDDIETPADST  AND
      DTSERVTRAN   = @P_DTSERVTRAN   AND
      CDFILAUXPRAT = @P_CDFILAUXPRAT AND
      CDPRATO      = @P_CDPRATO      AND
      NRSERVTRAN   = @P_NRSERVTRAN;

   SET @V_CONTAUXI = 1;
   WHILE (@V_CONTAUXI <= @P_QTCONTCOMPST)
   BEGIN
      INSERT INTO ETIQUETRAN
         (CDFILAUXPRAT,
          CDPRATO,
          CDFILIAL,
          CDSERVFILI,
          CDDIETPADST,
          CDDESTFILI,
          CDCLIENTE,
          NRSERVTRAN,
          DTSERVTRAN,
          NRSEQUETIQTR,
          QTPRATETIQTR)
      VALUES
         (@P_CDFILAUXPRAT,
          @P_CDPRATO,
          @P_CDFILIAL,
          @P_CDSERVFILI,
          @P_CDDIETPADST,
          @P_CDDESTFILI,
          @P_CDCLIENTE,
          @P_NRSERVTRAN,
          @P_DTSERVTRAN,
          RIGHT('0000' + CONVERT(VARCHAR, @V_CONTAUXI),4),
          @P_QTCONTAIST);
      SET @V_CONTAUXI = @V_CONTAUXI + 1;
   END;

   IF @P_QTCONTINCOST > 0 BEGIN
      SET @V_QTCONTINCOST = @P_QTCONTINCOST;
      IF @V_CONTAUXI > 1 BEGIN
         SET @V_QTCONTINCOST = @V_QTCONTINCOST + (@V_CONTAUXI - 1);
      END;
      WHILE (@V_CONTAUXI <= @V_QTCONTINCOST)
      BEGIN
         INSERT INTO ETIQUETRAN
            (CDFILAUXPRAT,
             CDPRATO,
             CDFILIAL,
             CDSERVFILI,
             CDDIETPADST,
             CDDESTFILI,
             CDCLIENTE,
             NRSERVTRAN,
             DTSERVTRAN,
             NRSEQUETIQTR,
             QTPRATETIQTR)
         VALUES
            (@P_CDFILAUXPRAT,
             @P_CDPRATO,
             @P_CDFILIAL,
             @P_CDSERVFILI,
             @P_CDDIETPADST,
             @P_CDDESTFILI,
             @P_CDCLIENTE,
             @P_NRSERVTRAN,
             @P_DTSERVTRAN,
             RIGHT('0000' + CONVERT(VARCHAR, @V_CONTAUXI),4),
             @P_QTPARCPRATST);
         SET @V_CONTAUXI = @V_CONTAUXI + 1;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_ETIQUETRAN','4.09.081';
GO

